<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995-7 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>16.5: Formatted Output
(<TT>printf</TT> and friends)</title>
<link href="sx2d.html" rev=precedes>
<link href="sx2f.html" rel=precedes>
<link href="sx2.html" rev=subdocument>
</head>
<body>
<H2>16.5: Formatted Output
(<TT>printf</TT> and friends)</H2>

<p>C's venerable <TT>printf</TT> function,
which we've been using since day one,
prints or writes formatted output to the standard output.
As we've seen
(by example, if not formally),
<TT>printf</TT>'s operation is controlled by its first,
``format'' argument,
which is either a simple string to be printed
or a string containing percent signs and other characters
which cause the formatted values of <TT>printf</TT>'s other arguments
to be interspersed with the other text (if any) of the format string.
</p><p>So far,
we've been using simple format specifiers
such as <TT>%d</TT>, <TT>%f</TT>, and <TT>%s</TT>.
But format specifiers can actually consist of several parts.
You can specify a ``field width'';
for example, <TT>%5d</TT> prints an integer in a field five characters wide,
padding the integer's value
with extra characters

if necessary
so that at least five characters are printed.
You can specify a ``precision'';
for example,
<TT>%.2f</TT> formats a floating-point number
with two digits printed after the decimal point.
You can also
add certain characters which
specify various options,
such as how a too-narrow field is to be padded out to its field width,
or what type of number you're printing.
For example, %-5d indicates that the padding characters
should be added after the field's value
(so that it's left-justified),
and %ld indicates that you're printing a <TT>long </TT>
instead of a plain <TT>int</TT>.
</p><p>Formally, then,
the complete framework
for a <TT>printf</TT> format specifier
looks like
<pre>
	% <I>flags</I> <I>width</I> . <I>precision</I> <I>modifier</I> <I>character</I>
</pre>
where all of the parts
except the <TT>%</TT> and the final

character
are optional.
</p><p>The <I>width</I> gives the <em>minimum</em> overall width of the output
(the <dfn>field</dfn>)
generated by this format specifier.
If the output (the number of digits or characters)
would be less than the width,
it will be padded on the right
(or left, if the <TT>-</TT> flag is present),
usually with spaces.
If the output for the field ends up being larger than the specified width,
however, the field essentially overflows or grows;
the output is not truncated or anything.
That is, <TT>printf("%2d", 12345)</TT> prints <TT>12345</TT>.
</p><p>The <I>precision</I> is either:
<UL><li>The number of digits printed after the decimal point,
for the floating-point formats <TT>%e</TT>, <TT>%f</TT>, and <TT>%g</TT>;
or
<li>The <em>maximum</em> number of characters to be printed,
for <TT>%s</TT>;
or
<li>The <em>minimum</em> number of digits to be printed,
for the integer formats <TT>%d</TT>, <TT>%o</TT>, <TT>%x</TT>, and <TT>%u</TT>.
</UL>For example,
<TT>printf("%.3s", "Hello, world!")</TT> prints <TT>Hel</TT>,
and
<TT>printf("%.5d", 12)</TT> prints <TT>00012</TT>.
</p><p>Either the <I>width</I> or the <I>precision</I>
(or both)
can be specified as <TT>*</TT>,
which indicates that the next <TT>int</TT> argument from the argument list
should be used as the field width or precision.
For example,
<TT>printf("%.*f", 2, 76.54321)</TT> prints <TT>76.54</TT>.
</p><p>The <I>flags</I> are a few optional characters
which modify the conversion in some way.
They are:
<UL><li><cw>-</>
Force left adjustment,
by padding
(out to the field width)
on the right.

<li><cw>0</>
Use 0 as the padding character,
instead of a space.
<li>space
For numeric formats,
if the converted number is positive,

leave an extra space before it
(so that it will line up with negative numbers if printed in columns).
<li><cw>+</>
Print positive numbers with a leading <TT>+</TT> sign.
<li><cw>#</>
Use an ``alternate form'' of the conversion.
(The details of the ``alternate forms'' are described below,
under the individual format characters.)
</UL></p><p>The <I>modifier</I> specifies the size of the corresponding argument:
<TT>l</TT> for <TT>long int</TT>,
<TT>h</TT> for <TT>short int</TT>,
<TT>L</TT> for <TT>long double</TT>.

</p><p>Finally,
the
format character
controls the overall appearance of the conversion
(and,
along with the <I>modifier</I>,
specifies the type of the corresponding argument).
We've seen many of these already.
The complete list of format characters is:
<UL><li><cw>c</>
Print a single character.
The corresponding argument is an <TT>int</TT>
(or,
by the default argument promotions,

a <TT>char</TT> or <TT>short int</TT>).
<li><cw>d</>
Print a decimal integer.
The corresponding argument is an <TT>int</TT>,
or a <TT>long int</TT> if the <TT>l</TT> modifier appears,
or a <TT>short int</TT> if the <TT>h</TT> modifier appears.
If the number is negative,
it is preceded by a <TT>-</TT>.
If the space flag appears and the the number is positive,

it is preceded by a space.
If the <TT>+</TT> flag appears and the the number is positive,
it is preceded by a <TT>+</TT>.
<li><cw>e</>
Print a floating-point number in scientific notation:
<TT>[-]m.nnnnnne[-]nn</TT>
.
The corresponding argument is
either a <TT>float</TT> or a <TT>double</TT>
or,
if the <TT>L</TT> modifier appears,
a <TT>long double</TT>.
The <I>precision</I> gives the number of places after the decimal point;
the default is 6.
If the <TT>#</TT> flag appears,
a decimal point will be printed even if the <I>precision</I> is 0.
<li><cw>E</>
Like <TT>e</TT>,
but use a capital <TT>E</TT> to set off the exponent.
<li><cw>f</>
Print a floating-point decimal number
(<TT>mmm.nnnnnn</TT>).
The corresponding argument is either
a <TT>float</TT> or a <TT>double</TT>
or,
if the <TT>L</TT> modifier appears,
a <TT>long double</TT>.
The <I>precision</I> gives the number of places after the decimal point;
the default is 6.
If the <TT>#</TT> flag appears,
a decimal point will be printed even if the <I>precision</I> is 0.
<li><cw>g</>
Use either <TT>e</TT> or <TT>f</TT>,
whichever works best given the range and precision of the number.

(Roughly speaking,
``works best'' means
to
display the most precision in the least space.)
If the <TT>#</TT> flag appears,
don't strip trailing <TT>0</TT>'s.
<li><cw>G</>
Like <TT>g</TT>,
but use <TT>E</TT> instead of <TT>e</TT>.
<li><cw>i</>
Just like <TT>d</TT>.
<li><cw>n</>
The corresponding argument is an <TT>int *</TT>.
Rather than printing anything,
<TT>%n</TT> stores the number of characters printed so far
(by this call to <TT>printf</TT>)
into the integer pointed to by the corresponding argument.
For example, if the variable <TT>np</TT> is an <TT>int</TT>,
<TT>printf("%s %n%s!", "Hello", &amp;n, "world")</TT>
stores 6 into <TT>np</TT>.
<li><cw>o</>
Print an unsigned integer, in octal (base 8).
The corresponding argument is an <TT>unsigned int</TT>,
or an <TT>unsigned long int</TT> if the <TT>l</TT> modifier appears,
or an <TT>unsigned short int</TT> if the <TT>h</TT> modifier appears.
If the <TT>#</TT> flag appears,
and the number is nonzero,
it will be preceded by an extra <TT>0</TT>,
to make it look like a C octal constant.
<li><cw>p</>
Print a pointer value
(the pointer, not what it points to),
in some implementation-defined format.
The corresponding argument is a <TT>void *</TT>.
Usually, the value printed
is the numeric value of the pointer--that is,
the memory address pointed to--in
hexadecimal.
For the segmented architecture of the IBM PC,
pointers are often printed using a <TT>segment:offset</TT> notation.
<li><cw>s</>
Print a string.
The corresponding argument is a <TT>char *</TT>
(which may result from an array of <TT>char</TT>).
If the optional <I>precision</I> is present,
at most that many characters of the string will be printed
(if the <TT>\0</TT> isn't encountered first).
<li><cw>u</>
Print an unsigned decimal integer.
The corresponding argument is an <TT>unsigned int</TT>,
or an <TT>unsigned long int</TT> if the <TT>l</TT> modifier appears,
or an <TT>unsigned short int</TT>
if the <TT>h</TT> modifier appears.
<li><cw>x</>
Print an unsigned integer, in hexadecimal (base 16).
The corresponding argument is an <TT>unsigned int</TT>,
or an <TT>unsigned long int</TT> if the <TT>l</TT> modifier appears,
or an <TT>unsigned short int</TT> if the <TT>h</TT> modifier appears.
If the <TT>#</TT> flag appears,
and the number is nonzero,
it will be preceded by the characters <TT>0x</TT>,
to make it look like a C hexadecimal constant.
<li><cw>X</>
Like <TT>x</TT>,
except that the capital letters
<TT>A</TT>, <TT>B</TT>, <TT>C</TT>, <TT>D</TT>, <TT>E</TT>, and <TT>F</TT>
are used for the hexadecimal digits 10-15.
(Also, the <TT>#</TT> flag leads to a leading <TT>0X</TT>.)
<li><cw>%</>
Print a single <TT>%</TT> sign.
There is no corresponding argument.
</UL>
</p><p>When you want to print to an arbitrary stream,
instead of standard output,
just use <TT>fprintf</TT>,
which takes a leading <TT>FILE *</TT> argument:
<pre>
	fprintf(stderr, "Syntax error on line %d\n", lineno);
</pre>
</p><p>Sometimes,
it's useful to do some <TT>printf</TT>-like formatting,
but <em>not</em> output the string right away.
The <TT>sprintf</TT> function is a <TT>printf</TT> variant
which ``prints'' to an in-memory string
rather than to a <TT>FILE *</TT> stream.
For example,
one way to convert an integer to a string
(the opposite of <TT>atoi</TT>)
is:
<pre>
	int i = 123;
	char string[20];
	sprintf(string, "%d", i);
</pre>
One thing to be careful of with <TT>sprintf</TT>,
though,
is that it's up to you
to make sure that the destination string
is big enough.
</p><hr>
<p>
Read sequentially:
<a href="sx2d.html" rev=precedes>prev</a>
<a href="sx2f.html" rel=precedes>next</a>
<a href="sx2.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1996-1999
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
